<html>
<head>
<title>OgreSIMDHelper.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_421e028b72e6118d2afd1c1cfce2a3b8.html">src</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSIMDHelper.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSIMDHelper_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __SIMDHelper_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __SIMDHelper_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlatformInformation_8h.html">OgrePlatformInformation.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Stack-alignment hackery.</span>
<a name="l00035"></a>00035 <span class="comment">//</span>
<a name="l00036"></a>00036 <span class="comment">// If macro __OGRE_SIMD_ALIGN_STACK defined, means there requests</span>
<a name="l00037"></a>00037 <span class="comment">// special code to ensure stack align to a 16-bytes boundary.</span>
<a name="l00038"></a>00038 <span class="comment">//</span>
<a name="l00039"></a>00039 <span class="comment">// Note:</span>
<a name="l00040"></a>00040 <span class="comment">//   This macro can only guarantee callee stack pointer (esp) align</span>
<a name="l00041"></a>00041 <span class="comment">// to a 16-bytes boundary, but not that for frame pointer (ebp).</span>
<a name="l00042"></a>00042 <span class="comment">// Because most compiler might use frame pointer to access to stack</span>
<a name="l00043"></a>00043 <span class="comment">// variables, so you need to wrap those alignment required functions</span>
<a name="l00044"></a>00044 <span class="comment">// with extra function call.</span>
<a name="l00045"></a>00045 <span class="comment">//</span>
<a name="l00046"></a>00046 <span class="preprocessor">#if defined(__INTEL_COMPILER)</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="comment">// For intel&#39;s compiler, simply calling alloca seems to do the right</span>
<a name="l00048"></a>00048 <span class="comment">// thing. The size of the allocated block seems to be irrelevant.</span>
<a name="l00049"></a>00049 <span class="preprocessor">#define __OGRE_SIMD_ALIGN_STACK()   _alloca(16)</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a>00051 <span class="preprocessor">#elif OGRE_CPU == OGRE_CPU_X86 &amp;&amp; (OGRE_COMPILER == OGRE_COMPILER_GNUC || OGRE_COMPILER == OGRE_COMPILER_CLANG)</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="comment">//</span>
<a name="l00053"></a>00053 <span class="comment">// Horrible hack to align the stack to a 16-bytes boundary for gcc.</span>
<a name="l00054"></a>00054 <span class="comment">//</span>
<a name="l00055"></a>00055 <span class="comment">// We assume a gcc version &gt;= 2.95 so that</span>
<a name="l00056"></a>00056 <span class="comment">// -mreferred-stack-boundary works.  Otherwise, all bets are</span>
<a name="l00057"></a>00057 <span class="comment">// off.  However, -mreferred-stack-boundary does not create a</span>
<a name="l00058"></a>00058 <span class="comment">// stack alignment, but it only preserves it.  Unfortunately,</span>
<a name="l00059"></a>00059 <span class="comment">// since Ogre are designed as a flexibility library, user might</span>
<a name="l00060"></a>00060 <span class="comment">// compile their application with wrong stack alignment, even</span>
<a name="l00061"></a>00061 <span class="comment">// if user taken care with stack alignment, but many versions</span>
<a name="l00062"></a>00062 <span class="comment">// of libc on linux call main() with the wrong initial stack</span>
<a name="l00063"></a>00063 <span class="comment">// alignment the result that the code is now pessimally aligned</span>
<a name="l00064"></a>00064 <span class="comment">// instead of having a 50% chance of being correct.</span>
<a name="l00065"></a>00065 <span class="comment">//</span>
<a name="l00066"></a>00066 <span class="preprocessor">#if OGRE_ARCH_TYPE != OGRE_ARCHITECTURE_64</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00068"></a>00068 <span class="preprocessor">#define __OGRE_SIMD_ALIGN_STACK()                                   \</span>
<a name="l00069"></a>00069 <span class="preprocessor">    {                                                               \</span>
<a name="l00070"></a>00070 <span class="preprocessor">        </span><span class="comment">/* Use alloca to allocate some memory on the stack.  */</span>     \
<a name="l00071"></a>00071         <span class="comment">/* This alerts gcc that something funny is going on, */</span>     \
<a name="l00072"></a>00072         <span class="comment">/* so that it does not omit the frame pointer etc.   */</span>     \
<a name="l00073"></a>00073         (void)__builtin_alloca(16);                                 \
<a name="l00074"></a>00074         <span class="comment">/* Now align the stack pointer */</span>                           \
<a name="l00075"></a>00075         __asm__ __volatile__ (&quot;andl $-16, %esp&quot;);                   \
<a name="l00076"></a>00076     }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="preprocessor">#else // 64</span>
<a name="l00079"></a><a class="code" href="OgreSIMDHelper_8h.html#a751b240bcf7b34507a4e9306be08a0e4">00079</a> <span class="preprocessor"></span><span class="preprocessor">#define __OGRE_SIMD_ALIGN_STACK()                                   \</span>
<a name="l00080"></a>00080 <span class="preprocessor">    {                                                               \</span>
<a name="l00081"></a>00081 <span class="preprocessor">        </span><span class="comment">/* Use alloca to allocate some memory on the stack.  */</span>     \
<a name="l00082"></a>00082         <span class="comment">/* This alerts gcc that something funny is going on, */</span>     \
<a name="l00083"></a>00083         <span class="comment">/* so that it does not omit the frame pointer etc.   */</span>     \
<a name="l00084"></a>00084         (void)__builtin_alloca(16);                                 \
<a name="l00085"></a>00085         <span class="comment">/* Now align the stack pointer */</span>                           \
<a name="l00086"></a>00086         __asm__ __volatile__ (&quot;andq $-16, %rsp&quot;);                   \
<a name="l00087"></a>00087     }
<a name="l00088"></a>00088 <span class="preprocessor">#endif //64</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span>
<a name="l00090"></a>00090 <span class="preprocessor">#elif defined(_MSC_VER)</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span><span class="comment">// Fortunately, MSVC will align the stack automatically</span>
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="preprocessor">#endif</span>
<a name="l00094"></a>00094 <span class="preprocessor"></span>
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 <span class="comment">// Additional platform-dependent header files and declares.</span>
<a name="l00097"></a>00097 <span class="comment">//</span>
<a name="l00098"></a>00098 <span class="comment">// NOTE: Should be sync with __OGRE_HAVE_SSE macro.</span>
<a name="l00099"></a>00099 <span class="comment">//</span>
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 <span class="preprocessor">#if OGRE_DOUBLE_PRECISION == 0 &amp;&amp; OGRE_CPU == OGRE_CPU_X86</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span>
<a name="l00103"></a>00103 <span class="comment">// GCC version 4.0 upwards should be reliable for official SSE now,</span>
<a name="l00104"></a>00104 <span class="comment">// so no longer define SSE macros ourselves</span>
<a name="l00105"></a>00105 <span class="comment">// We don&#39;t support gcc 3.x anymore anyway, although that had SSE it was a bit flaky?</span>
<a name="l00106"></a>00106 <span class="preprocessor">#include &lt;xmmintrin.h&gt;</span>
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="preprocessor">#endif // OGRE_DOUBLE_PRECISION == 0 &amp;&amp; OGRE_CPU == OGRE_CPU_X86</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00114"></a>00114 <span class="comment">// SIMD macros and helpers</span>
<a name="l00115"></a>00115 <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 <span class="keyword">namespace </span>Ogre {
<a name="l00126"></a>00126 <span class="preprocessor">#if __OGRE_HAVE_SSE</span>
<a name="l00127"></a>00127 <span class="preprocessor"></span>
<a name="l00138"></a>00138 <span class="preprocessor">#if 1</span>
<a name="l00139"></a>00139 <span class="preprocessor"></span><span class="preprocessor">#define __MM_RSQRT_PS(x)    _mm_rsqrt_ps(x)</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span><span class="preprocessor">#define __MM_RSQRT_PS(x)    __mm_rsqrt_nr_ps(x) // Implemented below</span>
<a name="l00142"></a>00142 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span>
<a name="l00152"></a>00152 <span class="preprocessor">#define __MM_TRANSPOSE4x4_PS(r0, r1, r2, r3)                                            \</span>
<a name="l00153"></a>00153 <span class="preprocessor">    {                                                                                   \</span>
<a name="l00154"></a>00154 <span class="preprocessor">        __m128 tmp3, tmp2, tmp1, tmp0;                                                  \</span>
<a name="l00155"></a>00155 <span class="preprocessor">                                                                                        \</span>
<a name="l00156"></a>00156 <span class="preprocessor">                                                            </span><span class="comment">/* r00 r01 r02 r03 */</span>       \
<a name="l00157"></a>00157                                                             <span class="comment">/* r10 r11 r12 r13 */</span>       \
<a name="l00158"></a>00158                                                             <span class="comment">/* r20 r21 r22 r23 */</span>       \
<a name="l00159"></a>00159                                                             <span class="comment">/* r30 r31 r32 r33 */</span>       \
<a name="l00160"></a>00160                                                                                         \
<a name="l00161"></a>00161         tmp0 = _mm_unpacklo_ps(r0, r1);                       <span class="comment">/* r00 r10 r01 r11 */</span>     \
<a name="l00162"></a>00162         tmp2 = _mm_unpackhi_ps(r0, r1);                       <span class="comment">/* r02 r12 r03 r13 */</span>     \
<a name="l00163"></a>00163         tmp1 = _mm_unpacklo_ps(r2, r3);                       <span class="comment">/* r20 r30 r21 r31 */</span>     \
<a name="l00164"></a>00164         tmp3 = _mm_unpackhi_ps(r2, r3);                       <span class="comment">/* r22 r32 r23 r33 */</span>     \
<a name="l00165"></a>00165                                                                                         \
<a name="l00166"></a>00166         r0 = _mm_movelh_ps(tmp0, tmp1);                         <span class="comment">/* r00 r10 r20 r30 */</span>   \
<a name="l00167"></a>00167         r1 = _mm_movehl_ps(tmp1, tmp0);                         <span class="comment">/* r01 r11 r21 r31 */</span>   \
<a name="l00168"></a>00168         r2 = _mm_movelh_ps(tmp2, tmp3);                         <span class="comment">/* r02 r12 r22 r32 */</span>   \
<a name="l00169"></a>00169         r3 = _mm_movehl_ps(tmp3, tmp2);                         <span class="comment">/* r03 r13 r23 r33 */</span>   \
<a name="l00170"></a>00170     }
<a name="l00171"></a>00171 
<a name="l00180"></a>00180 <span class="preprocessor">#define __MM_TRANSPOSE4x3_PS(v0, v1, v2)                                                \</span>
<a name="l00181"></a>00181 <span class="preprocessor">    {                                                                                   \</span>
<a name="l00182"></a>00182 <span class="preprocessor">        __m128 tmp0, tmp1, tmp2;                                                        \</span>
<a name="l00183"></a>00183 <span class="preprocessor">                                                                                        \</span>
<a name="l00184"></a>00184 <span class="preprocessor">                                                            </span><span class="comment">/* r00 r01 r02 r10 */</span>       \
<a name="l00185"></a>00185                                                             <span class="comment">/* r11 r12 r20 r21 */</span>       \
<a name="l00186"></a>00186                                                             <span class="comment">/* r22 r30 r31 r32 */</span>       \
<a name="l00187"></a>00187                                                                                         \
<a name="l00188"></a>00188         tmp0 = _mm_shuffle_ps(v0, v2, _MM_SHUFFLE(3,0,3,0));  <span class="comment">/* r00 r10 r22 r32 */</span>     \
<a name="l00189"></a>00189         tmp1 = _mm_shuffle_ps(v0, v1, _MM_SHUFFLE(1,0,2,1));  <span class="comment">/* r01 r02 r11 r12 */</span>     \
<a name="l00190"></a>00190         tmp2 = _mm_shuffle_ps(v1, v2, _MM_SHUFFLE(2,1,3,2));  <span class="comment">/* r20 r21 r30 r31 */</span>     \
<a name="l00191"></a>00191                                                                                         \
<a name="l00192"></a>00192         v0 = _mm_shuffle_ps(tmp0, tmp2, _MM_SHUFFLE(2,0,1,0));  <span class="comment">/* r00 r10 r20 r30 */</span>   \
<a name="l00193"></a>00193         v1 = _mm_shuffle_ps(tmp1, tmp2, _MM_SHUFFLE(3,1,2,0));  <span class="comment">/* r01 r11 r21 r31 */</span>   \
<a name="l00194"></a>00194         v2 = _mm_shuffle_ps(tmp1, tmp0, _MM_SHUFFLE(3,2,3,1));  <span class="comment">/* r02 r12 r22 r32 */</span>   \
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196 
<a name="l00204"></a>00204 <span class="preprocessor">#define __MM_TRANSPOSE3x4_PS(v0, v1, v2)                                            \</span>
<a name="l00205"></a>00205 <span class="preprocessor">    {                                                                               \</span>
<a name="l00206"></a>00206 <span class="preprocessor">        __m128 tmp0, tmp1, tmp2;                                                    \</span>
<a name="l00207"></a>00207 <span class="preprocessor">                                                                                    \</span>
<a name="l00208"></a>00208 <span class="preprocessor">                                                            </span><span class="comment">/* r00 r10 r20 r30 */</span>   \
<a name="l00209"></a>00209                                                             <span class="comment">/* r01 r11 r21 r31 */</span>   \
<a name="l00210"></a>00210                                                             <span class="comment">/* r02 r12 r22 r32 */</span>   \
<a name="l00211"></a>00211                                                                                     \
<a name="l00212"></a>00212         tmp0 = _mm_shuffle_ps(v0, v2, _MM_SHUFFLE(2,0,3,1));  <span class="comment">/* r10 r30 r02 r22 */</span>   \
<a name="l00213"></a>00213         tmp1 = _mm_shuffle_ps(v1, v2, _MM_SHUFFLE(3,1,3,1));  <span class="comment">/* r11 r31 r12 r32 */</span>   \
<a name="l00214"></a>00214         tmp2 = _mm_shuffle_ps(v0, v1, _MM_SHUFFLE(2,0,2,0));  <span class="comment">/* r00 r20 r01 r21 */</span>   \
<a name="l00215"></a>00215                                                                                     \
<a name="l00216"></a>00216         v0 = _mm_shuffle_ps(tmp2, tmp0, _MM_SHUFFLE(0,2,2,0));  <span class="comment">/* r00 r01 r02 r10 */</span>   \
<a name="l00217"></a>00217         v1 = _mm_shuffle_ps(tmp1, tmp2, _MM_SHUFFLE(3,1,2,0));  <span class="comment">/* r11 r12 r20 r21 */</span>   \
<a name="l00218"></a>00218         v2 = _mm_shuffle_ps(tmp0, tmp1, _MM_SHUFFLE(3,1,1,3));  <span class="comment">/* r22 r30 r31 r32 */</span>   \
<a name="l00219"></a>00219     }
<a name="l00220"></a>00220 
<a name="l00224"></a>00224 <span class="preprocessor">#define __MM_SELECT(v, fp)                                                          \</span>
<a name="l00225"></a>00225 <span class="preprocessor">    _mm_shuffle_ps((v), (v), _MM_SHUFFLE((fp),(fp),(fp),(fp)))</span>
<a name="l00226"></a>00226 <span class="preprocessor"></span>
<a name="l00228"></a>00228 <span class="preprocessor">#define __MM_ACCUM4_PS(a, b, c, d)                                                  \</span>
<a name="l00229"></a>00229 <span class="preprocessor">    _mm_add_ps(_mm_add_ps(a, b), _mm_add_ps(c, d))</span>
<a name="l00230"></a>00230 <span class="preprocessor"></span>
<a name="l00234"></a>00234 <span class="preprocessor">#define __MM_DOT4x4_PS(a0, a1, a2, a3, b0, b1, b2, b3)                              \</span>
<a name="l00235"></a>00235 <span class="preprocessor">    __MM_ACCUM4_PS(_mm_mul_ps(a0, b0), _mm_mul_ps(a1, b1), _mm_mul_ps(a2, b2), _mm_mul_ps(a3, b3))</span>
<a name="l00236"></a>00236 <span class="preprocessor"></span>
<a name="l00240"></a>00240 <span class="preprocessor">#define __MM_DOT4x3_PS(r0, r1, r2, r3, v0, v1, v2)                                  \</span>
<a name="l00241"></a>00241 <span class="preprocessor">    __MM_ACCUM4_PS(_mm_mul_ps(r0, v0), _mm_mul_ps(r1, v1), _mm_mul_ps(r2, v2), r3)</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span>
<a name="l00244"></a>00244 <span class="preprocessor">#define __MM_ACCUM3_PS(a, b, c)                                                     \</span>
<a name="l00245"></a>00245 <span class="preprocessor">    _mm_add_ps(_mm_add_ps(a, b), c)</span>
<a name="l00246"></a>00246 <span class="preprocessor"></span>
<a name="l00250"></a>00250 <span class="preprocessor">#define __MM_DOT3x3_PS(r0, r1, r2, v0, v1, v2)                                      \</span>
<a name="l00251"></a>00251 <span class="preprocessor">    __MM_ACCUM3_PS(_mm_mul_ps(r0, v0), _mm_mul_ps(r1, v1), _mm_mul_ps(r2, v2))</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span>
<a name="l00254"></a>00254 <span class="preprocessor">#define __MM_MADD_PS(a, b, c)                                                       \</span>
<a name="l00255"></a>00255 <span class="preprocessor">    _mm_add_ps(_mm_mul_ps(a, b), c)</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>
<a name="l00258"></a>00258 <span class="preprocessor">#define __MM_LERP_PS(t, a, b)                                                       \</span>
<a name="l00259"></a>00259 <span class="preprocessor">    __MM_MADD_PS(_mm_sub_ps(b, a), t, a)</span>
<a name="l00260"></a>00260 <span class="preprocessor"></span>
<a name="l00262"></a>00262 <span class="preprocessor">#define __MM_MADD_SS(a, b, c)                                                       \</span>
<a name="l00263"></a>00263 <span class="preprocessor">    _mm_add_ss(_mm_mul_ss(a, b), c)</span>
<a name="l00264"></a>00264 <span class="preprocessor"></span>
<a name="l00266"></a>00266 <span class="preprocessor">#define __MM_LERP_SS(t, a, b)                                                       \</span>
<a name="l00267"></a>00267 <span class="preprocessor">    __MM_MADD_SS(_mm_sub_ss(b, a), t, a)</span>
<a name="l00268"></a>00268 <span class="preprocessor"></span>
<a name="l00270"></a>00270 <span class="preprocessor">#define __MM_LOAD_PS(p)                                                             \</span>
<a name="l00271"></a>00271 <span class="preprocessor">    (*(__m128*)(p))</span>
<a name="l00272"></a>00272 <span class="preprocessor"></span>
<a name="l00274"></a>00274 <span class="preprocessor">#define __MM_STORE_PS(p, v)                                                         \</span>
<a name="l00275"></a>00275 <span class="preprocessor">    (*(__m128*)(p) = (v))</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span>
<a name="l00277"></a>00277 
<a name="l00280"></a>00280     <span class="keyword">template</span> &lt;<span class="keywordtype">bool</span> aligned = false&gt;
<a name="l00281"></a>00281     <span class="keyword">struct </span>SSEMemoryAccessor
<a name="l00282"></a>00282     {
<a name="l00283"></a>00283         <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> __m128 load(<span class="keyword">const</span> <span class="keywordtype">float</span> *p)
<a name="l00284"></a>00284         {
<a name="l00285"></a>00285             <span class="keywordflow">return</span> _mm_loadu_ps(p);
<a name="l00286"></a>00286         }
<a name="l00287"></a>00287         <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <span class="keywordtype">void</span> store(<span class="keywordtype">float</span> *p, <span class="keyword">const</span> __m128&amp; v)
<a name="l00288"></a>00288         {
<a name="l00289"></a>00289             _mm_storeu_ps(p, v);
<a name="l00290"></a>00290         }
<a name="l00291"></a>00291     };
<a name="l00292"></a>00292     <span class="comment">// Special aligned accessor</span>
<a name="l00293"></a>00293     <span class="keyword">template</span> &lt;&gt;
<a name="l00294"></a>00294     <span class="keyword">struct </span>SSEMemoryAccessor&lt;true&gt;
<a name="l00295"></a>00295     {
<a name="l00296"></a>00296         <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <span class="keyword">const</span> __m128&amp; load(<span class="keyword">const</span> <span class="keywordtype">float</span> *p)
<a name="l00297"></a>00297         {
<a name="l00298"></a>00298             <span class="keywordflow">return</span> __MM_LOAD_PS(p);
<a name="l00299"></a>00299         }
<a name="l00300"></a>00300         <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <span class="keywordtype">void</span> store(<span class="keywordtype">float</span> *p, <span class="keyword">const</span> __m128&amp; v)
<a name="l00301"></a>00301         {
<a name="l00302"></a>00302             __MM_STORE_PS(p, v);
<a name="l00303"></a>00303         }
<a name="l00304"></a>00304     };
<a name="l00305"></a>00305 
<a name="l00308"></a>00308     <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <span class="keywordtype">bool</span> _isAlignedForSSE(<span class="keyword">const</span> <span class="keywordtype">void</span> *p)
<a name="l00309"></a>00309     {
<a name="l00310"></a>00310         <span class="keywordflow">return</span> (((<span class="keywordtype">size_t</span>)p) &amp; 15) == 0;
<a name="l00311"></a>00311     }
<a name="l00312"></a>00312 
<a name="l00316"></a>00316     <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> __m128 __mm_rsqrt_nr_ps(<span class="keyword">const</span> __m128&amp; x)
<a name="l00317"></a>00317     {
<a name="l00318"></a>00318         <span class="keyword">static</span> <span class="keyword">const</span> __m128 v0pt5 = { 0.5f, 0.5f, 0.5f, 0.5f };
<a name="l00319"></a>00319         <span class="keyword">static</span> <span class="keyword">const</span> __m128 v3pt0 = { 3.0f, 3.0f, 3.0f, 3.0f };
<a name="l00320"></a>00320         __m128 t = _mm_rsqrt_ps(x);
<a name="l00321"></a>00321         <span class="keywordflow">return</span> _mm_mul_ps(_mm_mul_ps(v0pt5, t),
<a name="l00322"></a>00322             _mm_sub_ps(v3pt0, _mm_mul_ps(_mm_mul_ps(x, t), t)));
<a name="l00323"></a>00323     }
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 <span class="comment">// Macro to check the stack aligned for SSE</span>
<a name="l00326"></a>00326 <span class="preprocessor">#if OGRE_DEBUG_MODE</span>
<a name="l00327"></a>00327 <span class="preprocessor"></span><span class="preprocessor">#define __OGRE_CHECK_STACK_ALIGNED_FOR_SSE()        \</span>
<a name="l00328"></a>00328 <span class="preprocessor">    {                                               \</span>
<a name="l00329"></a>00329 <span class="preprocessor">        __m128 test;                                \</span>
<a name="l00330"></a>00330 <span class="preprocessor">        assert(_isAlignedForSSE(&amp;test));            \</span>
<a name="l00331"></a>00331 <span class="preprocessor">    }</span>
<a name="l00332"></a>00332 <span class="preprocessor"></span>
<a name="l00333"></a>00333 <span class="preprocessor">#else   // !OGRE_DEBUG_MODE</span>
<a name="l00334"></a>00334 <span class="preprocessor"></span><span class="preprocessor">#define __OGRE_CHECK_STACK_ALIGNED_FOR_SSE()</span>
<a name="l00335"></a>00335 <span class="preprocessor"></span>
<a name="l00336"></a>00336 <span class="preprocessor">#endif  // OGRE_DEBUG_MODE</span>
<a name="l00337"></a>00337 <span class="preprocessor"></span>
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 <span class="preprocessor">#endif  // __OGRE_HAVE_SSE</span>
<a name="l00340"></a>00340 <span class="preprocessor"></span>
<a name="l00343"></a>00343 }
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 <span class="preprocessor">#endif // __SIMDHelper_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
